/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../config.h"
#include <DSNetwork.h>
#include <DSConfigFile.h>
#include <DSComponent.h>
#include "../Shared.h"
#include "../filters.h"
#include "../moddecl.h"

DSHashTable *protocols;

extern "C" {
int libnetpr_filter_type()
{
	int i;
	protocols=new DSHashTable();
	DSComponent prot(protocols);
	i=prot.loadComponentsPrefixed(componentdir "/filters/netproto", "address_type","filter");
#ifdef WITH_DEBUG
	printf("%s: Loaded %i address filter components\n",__FILE__,i);
#endif
	/* This value is ignored for filters */
	return 0;
}

BOOL libnetpr_filter(Connection * conn,int type)
{
	proc_filter addr_filter;
	int atype;
	atype=conn->getSourceAddressType();
	addr_filter=(proc_filter)protocols->getPtrValue(atype);
	if (addr_filter) {
		return addr_filter(conn, type);
	} else {
		return config.getValueInt("defaults","allow unknown address types",0);
	}
	return FALSE;
}
}
