/* ANTINAT
 * =======
 * This software is Copyright (c) 2003-04 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../../config.h"
#include <DSNetwork.h>
#include <DSConfigFile.h>
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include "../../Shared.h"
#include "../../Connection.h"
#include "../../loggers.h"


extern "C" {
int libv4conn_v4command_type()
{
	return 0x01;
}
}


BOOL v4conn_command(Connection * conn)
{
	SOCKET remote;
	SOCKADDR * addr;
	sl_t addrlen;
	SOCKADDR_IN sout;
	sl_t soutlen;
	conn->getDestSockaddr(&addr, &addrlen);
	remote=socket(addr->sa_family, SOCK_STREAM, 0);
	if (connect(remote, addr, addrlen)!=0) {
		conn->sendResponsev4(91, 0, 0);
		free(addr);
		closesocket(remote);
		return FALSE;
	}
#ifdef WITH_DEBUG
	printf("%s: Connected\n",__FILE__);
#endif
	free(addr);
	soutlen=sizeof(sout);
	if (getsockname(remote, (SOCKADDR *)&sout, &soutlen)==0) {
		conn->sendResponsev4(90, sout.sin_addr.s_addr,
			sout.sin_port);
	} else {
		conn->sendResponsev4(90, 0, 0);
	}
#ifdef WITH_DEBUG
	printf("%s: Send response to client\n",__FILE__);
#endif
	conn->log(LOG_TYPE_CONNECTIONESTABLISHED);
	conn->forwardData(remote);
	closesocket(remote);

	return TRUE;
}

extern "C" {
BOOL libv4conn_v4command(void * conn)
{
	return v4conn_command((Connection *)conn);
}
}


