/* ANTINAT
 * =======
 * This software is Copyright (c) 2003-04 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#ifndef _CONNFIVE_H
#define _CONNFIVE_H

#include "../../config.h"
#include "../Connection.h"
#include "../moddecl.h"
#include <DSList.h>

/* Remember: cast to this structure: DON'T ADD ANY DATA HERE! */
class ConnFive: public Connection {
	private:
	public:
		ConnFive(DSNetwork * thenet);
		ConnFive(SOCKADDR * sa, char * udppacket, int udplen);
		//~ConnFive();
		BOOL authUsernamePassword(const char * username, const char * passwd);
		BOOL getPasswordByUsername(const char * username, char ** passwd);
		BOOL sendResponsev5(char rep, SOCKADDR * sa = NULL);

		/* FIXME: Can't use proc_resolve, mutual dependency */
		proc_resolve getResolver(int nResolver);
		proc_revresolve getRevResolver(int nResolver);


};

int v5getNumResolvers();
int v5getNumRevResolvers();
int v5getNumUnpwAuth();
int v5getNumUnpwSrc();
int v5getNumCommands();
int v5getNumAuthenticators();

#endif

