/* ANTINAT
 * =======
 * This software is Copyright (c) 2003-04 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include <DSNetwork.h>
#include <antinat.h>
#include "iscmd5.h"

extern "C" {
extern int _an_socks5_hmacmd5_chap(const unsigned char *, int,
	const char *,unsigned char *) ;
}


BOOL hmacmd5_chap_cpp(const unsigned char * challenge, const char * passwd, unsigned char ** response, int * resplen)
{
	unsigned char * respbuf;
	respbuf=(unsigned char *)malloc(20);
	if (respbuf==NULL) return FALSE;
	if (_an_socks5_hmacmd5_chap(challenge,strlen((char *)challenge),
		passwd,respbuf)==AN_ERROR_SUCCESS) {
		*response=respbuf;
		*resplen=16;
		return TRUE;
	}
	free(respbuf);
	return FALSE;
}
extern "C" {
int libhmacmd5_chap_type()
{
	return 0x85;
}

BOOL libhmacmd5_chap(const unsigned char * challenge, const char * passwd, unsigned char ** response, int * resplen)
{
	return hmacmd5_chap_cpp(challenge,passwd,response,resplen);
}
}
