/* ANTINAT
 * =======
 * This software is Copyright (c) 2003-04 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../../config.h"
#include <DSNetwork.h>
#include <DSList.h>
#include <DSComponent.h>
#include "../ConnFive.h"
#include "../../moddecl.h"


BOOL cpp_unpw_auth(ConnFive * conn)
{
	unsigned char version;
	unsigned char length;
	char * username;
	char * passwd;
	char rep[3];
	BOOL authed;

	authed=FALSE;
	username=passwd=NULL;
	if (!conn->getChar(&version)) return FALSE;
	if (version!=1) return FALSE;
	if (!conn->getChar(&length)) return FALSE;

	/* getSlab null terminates */
	username=(char *)malloc(length+1);
	if (!conn->getSlab(username,length)) goto barfed;
	if (!conn->getChar(&length)) goto barfed;
	passwd=(char *)malloc(length+1);
	if (!conn->getSlab(passwd,length)) goto barfed;

	authed=conn->authUsernamePassword(username, passwd);

barfed:
	rep[0]=0x01;
	if (authed) {
#ifdef WITH_DEBUG
		printf("User %s authenticated\n", username);
#endif
		rep[1]='\0';
	} else {
#ifdef WITH_DEBUG
		printf("User %s NOT authenticated\n", username);
#endif
		rep[1]=0x01;
	}
	conn->sendData(rep,2);
	if (username) free(username);
	if (passwd) free(passwd);
	return authed;
}

extern "C" {
int libunpw_authenticator_type()
{
	if ((v5getNumUnpwSrc()==0)&&(v5getNumUnpwAuth()==0)) return -1;
	return 2;
}

BOOL libunpw_auth(void * conn)
{
	return cpp_unpw_auth((ConnFive *)conn);
}
}

